#!/usr/bin/env node
"use strict";
/**
 * use-hoisted-version
 * Update lerna package to use hoisted version of npm dependency
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const t = __importStar(require("io-ts"));
const E = __importStar(require("fp-ts/Either"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("fp-ts/Record"));
const T = __importStar(require("fp-ts/Task"));
const TE = __importStar(require("fp-ts/TaskEither"));
const IO = __importStar(require("fp-ts/IO"));
const Console = __importStar(require("fp-ts/Console"));
const D = __importStar(require("io-ts-docopt"));
const io_ts_docopt_1 = require("io-ts-docopt");
const PathReporter_1 = require("io-ts/lib/PathReporter");
const function_1 = require("fp-ts/function");
const StringifiedJSON_1 = require("@typescript-tools/io-ts/dist/lib/StringifiedJSON");
const PackageJsonDependencies_1 = require("@typescript-tools/io-ts/dist/lib/PackageJsonDependencies");
const hoisted_packages_1 = require("@typescript-tools/hoisted-packages");
const lerna_utils_1 = require("@typescript-tools/lerna-utils");
const stringify_json_1 = require("@typescript-tools/stringify-json");
const monorepo_root_1 = require("@typescript-tools/monorepo-root");
const trace_1 = require("@strong-roots-capital/trace");
const shades_1 = require("shades");
const ts_pattern_1 = require("ts-pattern");
const debug_1 = __importDefault(require("debug"));
const fast_deep_equal_1 = __importDefault(require("fast-deep-equal"));
const debug = {
    cmd: debug_1.default('hoist')
};
const docstring = `
Usage:
    use-hoisted-version <package>

Options:
    <package>    Path to package for which to update dependencies
`;
const CommandLineOptions = io_ts_docopt_1.withEncode(t.type({
    '<package>': t.string,
}), a => ({
    package: a['<package>']
}));
// Widens the type of a particular Err into Err
const err = (error) => error;
const decodeDocopt = function_1.flow(D.decodeDocopt, E.mapLeft(error => err({ type: 'docopt decode', error: PathReporter_1.PathReporter.report(E.left(error)).join('\n') })), TE.fromEither);
const readFile = (filename) => function_1.pipe(lerna_utils_1.readFile(filename), TE.mapLeft(error => err({ type: 'unable to read file', filename, error })));
const writeFile = (filename) => (contents) => function_1.pipe(contents, trace_1.trace(debug.cmd, `Writing file ${filename}`), lerna_utils_1.writeFile(filename), TE.mapLeft(error => err({ type: 'unable to write file', filename, error })));
const updateDependencies = (packageJson) => (hoistedPackages) => {
    const withHoistedDependencies = (deps) => function_1.pipe(O.fromNullable(deps), O.map(R.reduceWithIndex({}, (pkg, acc, version) => Object.assign(acc, { [pkg]: O.getOrElse(function_1.constant(version))(O.fromNullable(hoistedPackages.get(pkg))) }))), O.toUndefined);
    return function_1.pipe(readFile(packageJson), TE.chain((contents) => function_1.pipe(StringifiedJSON_1.StringifiedJSON(PackageJsonDependencies_1.PackageJsonDependencies).decode(contents), E.map(originalJson => function_1.pipe(originalJson, shades_1.mod('dependencies')(withHoistedDependencies), shades_1.mod('devDependencies')(withHoistedDependencies), shades_1.mod('optionalDependencies')(withHoistedDependencies), shades_1.mod('peerDependencies')(withHoistedDependencies), R.filter(value => value !== undefined), updatedJson => fast_deep_equal_1.default(originalJson, updatedJson)
        ? O.none
        : O.some(updatedJson))), E.mapLeft(errors => PathReporter_1.PathReporter.report(E.left(errors)).join('\n')), E.mapLeft(error => err({ type: 'unable to parse file', filename: packageJson, error })), TE.fromEither)), TE.chain(updates => function_1.pipe(updates, E.fromOption(() => err({ type: 'no-op' })), E.map(trace_1.trace(debug.cmd, 'Updating file', packageJson)), E.chain(function_1.flow(stringify_json_1.stringifyJSON(E.toError), E.mapLeft(error => err({ type: 'unable to stringify package.json', error })))), TE.fromEither, TE.chain(updates => function_1.pipe(writeFile(packageJson)(updates), TE.mapLeft(error => err({ type: 'unable to write file', filename: packageJson, error })))), TE.orElse(error => ts_pattern_1.match(error)
        .with({ type: 'no-op' }, () => TE.of(undefined))
        .otherwise(() => TE.left(error))))));
};
const main = function_1.pipe(decodeDocopt(CommandLineOptions, docstring), TE.chain(options => function_1.pipe(monorepo_root_1.monorepoRoot(options.package), E.map(root => ({ options, root })), TE.fromEither)), TE.chain(({ options, root }) => function_1.pipe(hoisted_packages_1.hoistedPackages(root), TE.chain(updateDependencies(path.resolve(options.package, 'package.json'))))), TE.fold(function_1.flow(Console.error, IO.chain(() => process.exit(1)), T.fromIO), function_1.constant(T.of(undefined))));
main();
//  LocalWords:  packageJson devDependencies optionalDependencies
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=use-hoisted-version.js.map